//	FRAG

varying vec2 texture_coordinate;
uniform sampler2D my_color_texture;
uniform vec2 resolution;
uniform sampler2D texture;
uniform sampler2D lightmap;
uniform float time;

void main(void) 
{
	vec4 pixel = gl_Color * texture2D(texture, gl_TexCoord[0].xy);	
	vec4 light = gl_Color * texture2D(lightmap, gl_TexCoord[0].xy);
	float bright = ((1-light.r) + (1-light.g) + (1-light.b)) / 3;

	vec4 average = vec4(
		(pixel.r + pixel.g + pixel.b - bright*(1.2)) / 3,
		(pixel.r + pixel.g + pixel.b - bright*(1.1)) / 3,
		(pixel.r + pixel.g + pixel.b - bright*(0.7)) / 3,
		1.0);

	vec4 pxoutput = mix(pixel, average, bright*.85);

	vec4 pxoutput2 = pxoutput;
	pxoutput.r = pxoutput.r;
	pxoutput.g = pxoutput.g;

	pxoutput = mix(pxoutput, pxoutput2, bright);
	pxoutput = mix(pxoutput, pixel, time);
	
	vec4 tint = pxoutput + (light-(1-bright));	// tints
	pxoutput = mix(tint, pxoutput, time);

	gl_FragColor = pxoutput;
}